// ASocket1153.h
#pragma once

//   - 
//ALX1153::ASocketClient
//ALX1153::ASocketServer<>
//ALX1153::ASocketServer<>::CsCL
//     9


//----------------------------------------------------------------
//   27  2009
//
//  583806791

//----------------------------------------------------------------
//   ::AfxSocketInit()  InitInstance() !


//----------------------------------------------------------------
			//      6- 
			//   "stdafx.h"   ( ,  
			//  STL     "stdafx.h" ):

				//	//  "stdafx.h"   
				//	//ALX1153::ASocketParent, ...   MS Visual Studio 6 
				//	#pragma warning (disable : 4786)
				//	#define ASocketUsesVS6
				//	#include <vector>
				//	#include <map>
				//	#include <algorithm>


			//----------------------------------------------------------------
			//  6       
			// .      
			//    #pragma warning (disable : 4786)  
			//    .   cpp-    -   


//
#include <afxsock.h>

//
#include <afxmt.h>

//STL
#include <vector>
#include <map>
#include <algorithm>
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//   
//
//							__________________________
//							|                        |
//							|    SRV                 |
//							|________________________|
//							|                        |
//							|  sCL(0)                |>----------< 1CL(1)
//							|  sCL(1)                |>---<
//							|  sCL(2)                |>---<
//							|  sCL(3)                |>----------< 1CL(2)
//							|  ..                    |>---<
//							|  ..                    |>----------< 1CL(3)
//							|  sCL (m_nClientsMax-1) |>---<
//							|________________________|


//"SRV"		-	 .     (sCL),
//				    ()  (1CL)
//"sCL"		-	     
//"1CL"		-	   

//  1CL    sCL,      ,     SRV- .
//    sCL-  
//  - 
//
//   sCL-    " " (ASocketClient::SManager_Resize())
//
//   sCL    ,  .
//       sCL ,   Listen(1)  
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//  :
//Us_...		-	,   
//Us_st...		-	 ,   
//VF_..			-	 .
//VF_SRV_...	-	   ("") .
//VF_...		-	      .
//					(       )
//SManager_...	-	     
//__			-	

//  CAsyncSocket
//	Receive
//	Send
//	OnReceive
//	OnSend
//	OnOutOfBandData
//	OnAccept
//	OnConnect
//	OnClose




////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//      ALX1153::ASocketParent

/*
#pragma once
#include "ASocket1153.h"

class CMyClient:public ALX1153::ASocketClient
{
	virtual void VF_OnReceive()
	{
		//    
		//Us_Receive(...);
	}


	virtual void VF_OnAfterClose(){}
	virtual void VF_OnConnected(){}
	virtual bool VF_FeedBackFromSend_RetTrueIfNeedCancel(DWORD dwdTicksPassed)
	{
		if(dwdTicksPassed>e_sendTOdefault)
		{
			TRACE("\r\n\r\nVF_FeedBackFromSend_RetTrueIfNeedCancel has stoped sending\r\n\r\n");
			return true;
		}

		Sleep(1);
		return false;
	}


	public: 

	CMyClient()
	{
	}

	~CMyClient()
	{
	}
};

class CMyClientData
{
	...
};

//    -   ,      
//   <> ,     
class CMyServer:public ALX1153::ASocketServer<CMyClientData> //.
{
	virtual void VF_OnReceive(const CsCL* sCL)
	{
		//1)
		//    
		//Us_Receive(...);
	}
	virtual void VF_OnAfterClose(const CsCL* sCL){}
	virtual void VF_Accepted(const CsCL*){}

	virtual bool VF_FeedBackFromSend_RetTrueIfNeedCancel(const CsCL* sCL,DWORD dwdTicksPassed)
	{
		if(dwdTicksPassed>e_sendTOdefault)
		{
			TRACE("\r\n\r\nVF_FeedBackFromSend_RetTrueIfNeedCancel has stoped sending\r\n\r\n");
			return true;
		}

		Sleep(1);
		return false;
	}

	//  
	virtual void VF_SRV_OnAfterServerCreated(){}

	public: 

	CMyServer()
	{
	}

	~CMyServer()
	{
	}
};

// 
CMyServer Server;
Server.Us_StartWorkingServer(1234,50,false);


//   
CMyServer Client;
Client.Us_StartWorkingClient("5.6.7.8",1234,false);

*/
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


#pragma pack(push,1)

//     
namespace ALX1153
{
	class ASocketParent;

	namespace ASocketH
	{

		enum ee_ServerConsts
		{
			//   
			e_srv_clients_max_count=	500
		};

		//  
		class CTimeOut
		{
			DWORD m_dwdBegin;
			DWORD m_dwdLast;
			DWORD m_dwdTO;
			bool m_bWasStarted;//- (, ,    ,   ,    )

		public:
			CTimeOut(DWORD dwdTO,bool bStartAtNow=false);
			void Start();
			void Restart();
			void Stop();
			int GetPercent_0_100();
			bool GotEnd(bool bFalseOnceIfWasGotEndWithoutAskingBetweenStartAndStop=false);
		};


		//   ,   
		class VoidUSERDATA
		{
		};
	};//ASocketH
};//ALX1153


namespace ALX1153
{
	//    
	class ASocketParent:public CAsyncSocket
	{

	public:
		// 
		enum ee_TO
		{
			e_sendTOdefault	=	5000	,	//
			e_FlashTO		=	500		,	//   
		};


	public:

		//   AsyncSelect()  
		long m_LastSetEventMask;

		//    
		ASocketH::CTimeOut m_DataWereSentTO;//    Send()
		ASocketH::CTimeOut m_DataWereRecvTO;//    Receive()

	public:
		ASocketParent();
		virtual ~ASocketParent();
	};

	class ASocketClient:public ASocketParent
	{
	public:
		//  
		class CStatistics
		{
			public:
			__int64 m_BytesReceived_all;//   ( CAsyncSocket::Receive())
			__int64 m_BytesSent_____all;//   ( CAsyncSocket::Send())

			CStatistics()
			{
				::memset(this,0,sizeof(*this));
			}
		};

	private:
		bool m_bIsConnected;			// 
		bool m_bBadDisconnect;			// ""  
		CStatistics m_Statistics;//    

	private:
		void operator=(const ASocketClient&){}// 

	#ifdef ASocketUsesVS6
	public:
	#else
	protected:
	#endif//ASocketUsesVS6
		virtual void __Set_m_bIsConnected(bool b)	{m_bIsConnected=b;}
		virtual void __Set_m_bBadDisconnect(bool b){m_bBadDisconnect=b;}
		virtual bool __Get_m_bIsConnected()const	{return m_bIsConnected;}
		virtual bool __Get_m_bBadDisconnect()const	{return m_bBadDisconnect;}


	private:
		bool __Polling(long Event,DWORD dwdTO,DWORD dwdTimeStep,bool (*WaitCancelCallBack)(int percent,void* pData),void* pData);

		//    
		void __SelectEvents_client_JustRefresh();

		//    
		void __SelectEvents_client(int B_On,bool bOnConnectAlways=false,bool bJustRefresh=false);

	public:

		//
		ASocketClient();
	
		//
		~ASocketClient();

		//       
		bool Us_CalcMonitorsRect(CDC& destDC,const CRect& LayoutRect)const;

		// ,   
		bool Us_IsClient__Connected();

		// ,      (    )
		bool Us_IsClient__BadDisconnectedAfterLastConnect()const;

		//  SOCKET ( )  
		bool Us_IsWorking_checkJustHandle()const;

		//    
		int Us_Send(const void* lpBuf, int nBufLen,int nFlags=0)const;
		int Us_Receive(void* lpBuf,const int nBufLen,int nFlags=0);

		//    IP  (  )   
		bool Us_StartWorkingClient(const char* pchAddress,WORD wServerPort,bool bPauseEventsBeforeWorking);

		//     
		void Us_StopWorking() const;

		// -      
		bool Us_GetIsEventOn_OnReceive();

		//   //
		void Us_PauseEvents();

		//   //
		void Us_StartEvents();

		//  -
		bool Us_GetPeerIP(DWORD& dwdIP,WORD& wPort)const;
		bool Us_GetPeerIP(CString& csIP,WORD& wPort)const;

		//  ASocketH::e_net_MaxOnceSendLen
		static int Us_GetMaxOneSendLen();

		//,     ,   
		//    
		//        WM_SOCKET_NOTIFY(FD_CONNECT) 
		//   (false).    Us_IsClient__Connected()
		//     true,      false
		bool Us_WaitOneConnectEvent(DWORD dwdTO=5000,DWORD dwdTimeStep=50,bool (*WaitCancelCallBack)(int percent,void* pData)=0,void* pData=0);

		//,     ,   
		//  
		//       WM_SOCKET_NOTIFY(FD_READ) 
		//  .    
		//     true,   
		//   ,      .
		bool Us_WaitOneReceiveEvent(DWORD dwdTO=10000,DWORD dwdTimeStep=50,bool (*WaitCancelCallBack)(int percent,void* pData)=0,void* pData=0);

		//,     ""  WM_SOCKET_NOTIFY(FD_WRITE)
		void Us_WaitAndRemoveSendEvents();


	private:
		//  
		virtual void OnClose(int nErrorCode);
		virtual void OnReceive(int nErrorCode);
		virtual void OnSend(int nErrorCode);
		virtual void OnOutOfBandData(int nErrorCode);
		virtual void OnConnect(int nErrorCode);
		virtual int Send(const void* lpBuf, int nBufLen, int nFlags=0);
		virtual int Receive(void* lpBuf, int nBufLen, int nFlags=0);

	protected:
		//  

		//  Send      
		//(,  (CAsyncSocket::Send()==SOCKET_ERROR 
		//this->GetLastError()==WSAEWOULDBLOCK)
		//dwdTicksPassed - ,       
		virtual bool VF_FeedBackFromSend_RetTrueIfNeedCancel(DWORD dwdTicksPassed)=0;

		//   
		virtual void VF_OnAfterClose()=0;

		//     (   Accept)
		virtual void VF_OnConnected()=0;

		//,      (    -
		//     )
		virtual void VF_OnReceive()=0;
	};

	template<class USERDATA=ASocketH::VoidUSERDATA>
	class ASocketServer:public ASocketParent
	{
	public:
		typedef USERDATA td_UserDataType;
		// 
		class CsCL:public ASocketClient
		{
			friend class ASocketServer;

			USERDATA m_UserData;		// 
			ASocketServer* m_pParentServer;//  -

			#ifdef ASocketUsesVS6
			public:
			#else
			private:
			#endif//ASocketUsesVS6
			DWORD m_Index_zb_nm1;		//   


		private:
			CsCL(){throw;}// 
			void operator=(const CsCL&){throw;}// 

		public:
			//    
			USERDATA* Us_GetUserData() const
			{
				return (USERDATA*)&m_UserData;
			}

			//    
			bool Us_IsWorking_checkJustHandle()const
			{
				return (m_hSocket && m_hSocket!=INVALID_SOCKET);
			}

			CsCL(ASocketServer* pParentServer,DWORD Index_zb_nm1=-1)
			{
				m_Index_zb_nm1=Index_zb_nm1;
				m_pParentServer=pParentServer;
			}

			//
			~CsCL()
			{
			}

			//----------------------------------------------------------------------------
		private:
			virtual void VF_OnReceive()
			{
				if(m_pParentServer)m_pParentServer->VF_OnReceive(this);
			}


			virtual bool VF_FeedBackFromSend_RetTrueIfNeedCancel(DWORD dwdTicksPassed)
			{
				if(m_pParentServer)return m_pParentServer->VF_FeedBackFromSend_RetTrueIfNeedCancel(this,dwdTicksPassed);

				return true;
			}

			virtual void OnClose(int nErrorCode)
			{
				// 

				//      ,  
				//   Us_StopWorking()

				if(m_pParentServer)
				{
					m_pParentServer->SManager_DeleteClient(this,nErrorCode);
					//     Listen(1),      
				}
				else
				{
					// , 
					ASocketParent::Close();
				}
			}
			//----------------------------------------------------------------------------

			//
			private:
				virtual void VF_OnAfterClose(){}
				virtual void VF_OnConnected(){}
		};

		private:// private!!!
		//-   CsCL    std::map
		struct CsCL_container
		{
			private:
			CsCL* m_p;

			public:
			CsCL* GetPointer()
			{
				return m_p;
			}

			CsCL_container()
			{
				m_p=0;
			}

			CsCL_container(ASocketServer* pParentServer)
			{
				m_p=new CsCL(pParentServer);
			}

			CsCL_container(const CsCL_container& src)
			{
				*this=src;
			}

			void operator=(const CsCL_container& src)
			{
				m_p=src.m_p;
				((CsCL_container*)&src)->m_p=0;
			}

			~CsCL_container()
			{
				if(m_p)
				{
					delete m_p;
					m_p=0;
				}
			}
		};

		private:
		WORD m_wServerPort;//  -   
		CCriticalSection m_critS;

		// - 
		typedef std::map<int,CsCL_container> td_ClientsMap;
		td_ClientsMap m_ServerClientsMap;


	protected:
		//,   
		virtual void VF_OnAfterClose	(const CsCL* sCL)=0;

		//,  
		virtual void VF_Accepted		(const CsCL* sCL)=0;

		//,  
		virtual void VF_SRV_OnAfterServerCreated()=0;

	#ifdef ASocketUsesVS6
	public:
	#else
	protected:
	#endif//ASocketUsesVS6
		//  Send      
		//(,  (CAsyncSocket::Send()==SOCKET_ERROR 
		//this->GetLastError()==WSAEWOULDBLOCK)
		//dwdTicksPassed - ,       
		virtual bool VF_FeedBackFromSend_RetTrueIfNeedCancel(const CsCL* sCL,DWORD dwdTicksPassed	)=0;

		//,      (    -
		//     )
		virtual void VF_OnReceive							(const CsCL* sCL						)=0;


	private:
		virtual void OnAccept(int nErrorCode)
		{
			//   
			{
				CsCL* scl=(CsCL*)SManager_CreateNewClient();

				if(scl)
				{
					scl->Us_StopWorking();

					if(Accept(*scl))
					{
						// 
						scl->Us_StartEvents();
					}

					if(!scl->Us_IsWorking_checkJustHandle())
					{
						scl->Us_StopWorking();
					}
					else
					{
						scl->__Set_m_bIsConnected(true);
						VF_Accepted(scl);
					}
				}
				else
				{
					// ,       
					CsCL temp(0);
					Accept(temp,0,0);
				}

				//   
				if(SManager_CreateNewClient(true)==0)
				{
					//  ,  
					// ,    Near   ( CsCL::OnClose)
					__ReStartWorkingWithNoListening();
				}
			}
		}

	public:
		ASocketServer()
		{
			m_wServerPort=0;
		}

		~ASocketServer()
		{
		}

		//          
		bool Us_CheckClientPointerEqualsTheIndex(DWORD Index_zb,const CsCL* cli_test)
		{
			if(!cli_test)return false;
			const CsCL* cli=SManager_GetClientByIndex(Index_zb);
			return(cli==cli_test);
		}

		//    
		bool Us_IsWorking_checkJustHandle()const
		{
			return (m_hSocket!=INVALID_SOCKET);
		}

		//   
		bool Us_IsClient__Connected(const CsCL* cli)
		{
			if(!SManager_GetClientByTestPointer(cli))return false;
		//	return __info_IsConnected(cli->statusFL);
			return cli->__Get_m_bIsConnected();
		}

		//   
		bool Us_IsClient__Connected(DWORD Index_zb)
		{
			//BYTE info;
			const CsCL* cli=SManager_GetClientByIndex(Index_zb);
			return Us_IsClient__Connected(cli);
		}

		//  ""  
		bool Us_IsClient__BadDisconnectedAfterLastConnect(DWORD Index_zb)
		{
			const CsCL* cli=SManager_GetClientByIndex(Index_zb,false);
			if(!cli)return false;
			return cli->__Get_m_bBadDisconnect();
		}

		//      
		const CsCL* Us_GetClientByIndex(DWORD Index_zb)
		{
			return SManager_GetClientByIndex(Index_zb);
		}

		//   
		void Us_SetClientCount(DWORD ClientsMax_in)
		{
			if(ClientsMax_in>ASocketH::e_srv_clients_max_count)
			{
				ClientsMax_in=0;
			}

			SManager_Resize(ClientsMax_in);
		}

		//    
		DWORD Us_GetClientsCount()
		{
			if(!Us_IsWorking_checkJustHandle())return 0;
			return SManager_GetMaxClientsCount();
		}

		// 
		bool Us_StartWorkingServer(WORD wServerPort,int nClientsCountLimit,bool bPauseEventsBeforeWorking)
		{
			if(m_hSocket!=INVALID_SOCKET)
			{
				ASocketParent::Close();
			}

			if(m_hSocket==INVALID_SOCKET)
			{
				if(nClientsCountLimit>=0)
				{
					m_wServerPort=wServerPort;
					if(Create(m_wServerPort,SOCK_STREAM,0))
					{
						SManager_Clear();
						SManager_Resize(nClientsCountLimit);


						VF_SRV_OnAfterServerCreated();
					
						Listen(1);

						if(bPauseEventsBeforeWorking)
						{
							__SelectEvents_server(0);
						}
						else
						{
							__SelectEvents_server(1);
						}

						return true;
					}
					else
					{
						if(this->GetLastError()==WSANOTINITIALISED)
						{
							::MessageBox(0,"   ::AfxSocketInit()  !","WSANOTINITIALISED",MB_SYSTEMMODAL|MB_ICONHAND);
						}
					}
				}
			}

			Us_StopWorking();
			return false;
		}

		// 
		void Us_StopWorking()
		{
			if(m_hSocket!=INVALID_SOCKET)
			{
				__SelectEvents_server(0);
				SManager_Clear();

				ASocketParent::Close();
			}
		}

	private:

		//    
		void __SelectEvents_server(int B_On)
		{
			if(m_hSocket==INVALID_SOCKET)return;

			if(!B_On)
			{
				m_LastSetEventMask=(0);
			}
			else
			{
				m_LastSetEventMask=(FD_ACCEPT);
			}

			AsyncSelect(m_LastSetEventMask);
		}

		// "" 
		void __ReStartWorkingWithNoListening()
		{
			ASocketParent::Close();

			if(m_hSocket==INVALID_SOCKET)
			{
				if(Create(m_wServerPort,SOCK_STREAM,0))
				{
					//Listen    ,      
					__SelectEvents_server(0);
				}

			}
		}
	private:
		//  m_ServerClientsMap     
		int			SManager_Resize(DWORD ClientsMax)
		{
			CSingleLock s(&m_critS,1);

			ClientsMax=min(ASocketH::e_srv_clients_max_count,ClientsMax);

			if(m_ServerClientsMap.size()==ClientsMax)
			{
				//  
			}
			else
			if(m_ServerClientsMap.size()>ClientsMax)
			{
				//    
				DWORD max_nzb=m_ServerClientsMap.size();
				while(max_nzb>0 && m_ServerClientsMap.size()>ClientsMax)
				{
					m_ServerClientsMap.erase(max_nzb-1);
					max_nzb--;
				}
			}
			else//if(m_ServerClientsMap.size()<ClientsMax)
			{
				// 
				DWORD max_zb=m_ServerClientsMap.size();
				while(max_zb<ClientsMax && m_ServerClientsMap.size()<ClientsMax)
				{
					m_ServerClientsMap[max_zb]=CsCL_container(this);
					max_zb++;
				}

				//  ,   -     
				Listen(1);
				__SelectEvents_server(1);
			}

			return m_ServerClientsMap.size();
		}

		void		SManager_Clear()
		{
			CSingleLock s(&m_critS,1);
			// "" 
			__ReStartWorkingWithNoListening();
			m_ServerClientsMap.clear();
		}

		const CsCL* SManager_GetClientByTestPointer(const CsCL* pSClientToFind)
		{
			if(pSClientToFind==0)return 0;
			if(pSClientToFind->m_Index_zb_nm1<0)return 0;
			if(pSClientToFind->m_Index_zb_nm1>=m_ServerClientsMap.size())return 0;

			//  
			td_ClientsMap::iterator it;

			it=m_ServerClientsMap.find(pSClientToFind->m_Index_zb_nm1);
			if(it==m_ServerClientsMap.end())return 0;
			if(it->second.GetPointer()!=pSClientToFind)return 0;

			return pSClientToFind;
		}

		//bExactly -      
		const CsCL* SManager_GetClientByIndex(DWORD Index_zb_nm1,bool bExactly=true)
		{
			if(Index_zb_nm1>=m_ServerClientsMap.size())return 0;

			//  
			td_ClientsMap::iterator it;

			it=m_ServerClientsMap.find(Index_zb_nm1);
			if(it==m_ServerClientsMap.end())return 0;
			const CsCL* p=it->second.GetPointer();
			if(!p)return 0;

			if(bExactly)
			{
				if(p->m_Index_zb_nm1!=Index_zb_nm1)return 0;
			}

			return p;
		}

		#ifdef ASocketUsesVS6
		public:
		#else
		private:
		#endif//ASocketUsesVS6
		// true,    
		void		SManager_DeleteClient(CsCL* pSClientToFindAndDelete,int nErrorCode)
		{
			CSingleLock s(&m_critS,1);

			bool bResult=false;

			//  

			CsCL*& pSCli=pSClientToFindAndDelete;
			bool bInArr=(SManager_GetClientByTestPointer(pSClientToFindAndDelete)!=0);

			if(pSCli)
			{
				//
				pSCli->Close();

				VF_OnAfterClose(pSCli);

				pSCli->m_Index_zb_nm1=-1;

				if(bInArr)
				{
					pSCli->__Set_m_bBadDisconnect(nErrorCode!=0);

					// - ,   
					Listen(1);
					__SelectEvents_server(1);
				}
			}
		}

		private:
		int			SManager_GetMaxClientsCount()
		{
			return m_ServerClientsMap.size();
		}

		CsCL*		SManager_CreateNewClient(bool bJustCheckIfCan_ButDontCreate_AndRet1=false)
		{
			CSingleLock s(&m_critS,1);

			td_ClientsMap::iterator it;

			for(it=m_ServerClientsMap.begin(); it!=m_ServerClientsMap.end();it++)
			{
				CsCL* p=it->second.GetPointer();
				if(p)
				{
					if(p->m_Index_zb_nm1==-1 || !p->Us_IsWorking_checkJustHandle() || !p->Us_IsClient__Connected())
					{
						if(bJustCheckIfCan_ButDontCreate_AndRet1)
						{
							return (CsCL*)1;
						}
						else
						{
							if(!p->Us_IsWorking_checkJustHandle() || !p->Us_IsClient__Connected())
							{
								SManager_DeleteClient(p,0);
							}

							if(p->m_Index_zb_nm1==-1)
							{
								p->m_Index_zb_nm1=it->first;
								return p;
							}
						}
					}
				}
			}

			return 0;
		}
	};
};//ALX1153


#pragma pack(pop)